<template>
  <v-container class="pa-0">
    <FlightsEditAddEditFlight :flight="flight" ref="form" />

    <LazyModificationsConfirmDialog v-model="showDialog" @confirm="discardChanges" @close="closeDialog" />
  </v-container>
</template>

<script setup lang="ts">
import type { RouteLocationNormalizedGeneric } from "vue-router";
import FlightsEditAddEditFlight from '~/components/flights/edit/AddEditFlight.vue'
import { Flight } from "~/dto/flight.dto";

const router = useRouter();

defineProps<{ flight: Flight }>()

const form = ref<InstanceType<typeof FlightsEditAddEditFlight>>();

const showDialog = ref(false);
const toRedirect = ref<RouteLocationNormalizedGeneric>();

onBeforeRouteLeave((to, from, next) => {
  if (!form.value?.isDirty || toRedirect.value) {
    next();
  } else {
    toRedirect.value = to;
    showDialog.value = true;
  }
})

const closeDialog = () => {
  showDialog.value = false;
  toRedirect.value = undefined;
};

const discardChanges = async () => {  
  showDialog.value = false;
  
  // FIXME: navigateTo is not doing the redirection, using router directly
  if (toRedirect.value) {
    router.push(toRedirect.value!);
  }
};

</script>
